<template>
  <div class="table-page">
    <div class="table-page-content">
      <div class="left-tree">
        <tree-side ref="treeSide" :dataLoading="treeLoading" :default-expand-all="false" :defaultProps="defaultProps"
                   :tabList="['组织路段树']" :treeData="treeData" isDeselect @currentChange="currentChange"></tree-side>
      </div>
      <div class="right-table">
        <div class="full-page bg">
          <div class="search-box">
            <div class="search-box-combination">
              <SearchCommon
                :optionList="optionList"
                @search="handleSearch"
              />
            </div>
          </div>
          <div class="main-table-container">
            <div class="table-container" style="padding: 20px">
              <div ref="btnPanel" class="btn-box">
                <el-button
                  :disabled="isAddDisabled"
                  class="btn btn-plus"
                  icon="el-icon-plus"
                  size="small"
                  type="primary"
                  @click="changePage('EditAddPage')"
                >
                  添加
                </el-button>
                <el-button
                  :disabled="!currentDataDel.length"
                  :loading="btnLoading"
                  class="btn btn-delete"
                  icon="el-icon-delete"
                  plain
                  size="small"
                  type="danger"
                  @click="handleDelete()"
                >
                  删除
                </el-button>
              </div>
              <div ref="tableRef" class="table-content">
                <el-table
                  ref="multipleSelection"
                  v-loading="tableLoading"
                  :data="tableData"
                  :default-sort="{prop: 'pegVal', order: 'ascending'}"
                  :max-height="tableMaxHeight"
                  border
                  class="table-list"
                  element-loading-background="rgba(10 ,38 ,61, 0.9)"
                  row-key="id"
                  stripe
                  @select="handleSelection"
                  @selection-change="handleSelectionChange"
                  @row-dblclick="handleDbClick"
                  @sort-change="sortChange"
                >
                  <el-table-column
                    align="center"
                    type="selection"
                    width="70"
                  />
                  <el-table-column
                    :index="index => index + 1 + (params.pageBean.page - 1) * params.pageBean.pageSize"
                    align="center"
                    label="序号"
                    type="index"
                    width="80"
                  />
                  <el-table-column
                    :formatter="({name}) => name || '-'"
                    align="center"
                    label="点位名称"
                    min-width="100"
                    prop="name"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="({roadName}) => roadName || '-'"
                    align="center"
                    label="所属路段"
                    min-width="100"
                    prop="roadName"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="({direction}) => dictionaryEscape('xsfx',direction) || '-'"
                    align="center"
                    label="方向"
                    min-width="80"
                    prop="direction"
                    show-overflow-tooltip
                    sortable="custom"
                  />
                  <el-table-column
                    :formatter="({pegVal}) => pegVal || '-'"
                    align="center"
                    label="点位桩号"
                    min-width="100"
                    prop="pegVal"
                    show-overflow-tooltip
                    sortable

                  />
                  <el-table-column
                    :formatter="({type}) => dictionaryEscape('xcdwlx',type) || '-'"
                    align="center"
                    label="点位类型"
                    min-width="100"
                    prop="type"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="({pointLevel}) => dictionaryEscape('dwjb',String(pointLevel)) || '-'"
                    align="center"
                    label="点位级别"
                    min-width="100"
                    prop="pointLevel"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="({inspectionCycle}) => dictionaryEscape('xjzq',String(inspectionCycle)) || '-'"
                    align="center"
                    label="巡检周期"
                    min-width="100"
                    prop="inspectionCycle"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="({content}) => content || '-'"
                    align="center"
                    label="内容"
                    min-width="60"
                    prop="content"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="({category}) => dictionaryEscape('xcdwlb',category) || '-'"
                    align="center"
                    label="点位类别"
                    min-width="100"
                    prop="category"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="({lng,lat}) => lng && lat ? `${lng},${lat}` : '-'"
                    align="center"
                    label="经度/纬度"
                    min-width="130"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="({createTime}) => createTime || '-'"
                    align="center"
                    label="登记时间"
                    min-width="100"
                    prop="createTime"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    align="center"
                    label="操作"
                    min-width="100"
                    show-overflow-tooltip
                  >
                    <template v-slot="{row}">
                      <el-link
                        :disabled="btnLoading"
                        :underline="false"
                        type="primary"
                        @click="handleDetailPage(row)"
                      >
                        详情
                      </el-link>
                      <el-link
                        :disabled="btnLoading"
                        :underline="false"
                        type="danger"
                        @click="handleDelete(row)"
                      >
                        删除
                      </el-link>
                    </template>
                  </el-table-column>
                </el-table>
                <pagination
                  ref="paginationPanel"
                  :pageResult="params.pageBean"
                  style="margin-top: 10px"
                  @size-change="handleSizeChange"
                  @current-change="handleCurrentChange"
                />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {dictionaryEscape, getDictionaryByCode} from '@/utils/dictionary'
import {getQueryValue, getSorterDirection, refineRequestBody, setQueryValue} from '@/utils/requestWrappers'
import pagination from '@/components/SuperPagination/index.vue'
import PubSub from 'pubsub-js'
import SearchCommon from '@/components/SearchCommon/index.vue'
import {TableMixin} from '@/mixins/tableMixin'
import {tableData, tableDelete} from '@/api/patrolAndRescue/infoMgmtPatrolsRescues/inspectionPointMgmt'
import treeSide from '@/components/treeSide/index.vue'
import {getTree} from '@/api/tree'

export default {
  name: 'TablePage',
  components: {
    treeSide,
    pagination,
    SearchCommon
  },
  mixins: [TableMixin],
  data() {
    return {
      isAddDisabled: true, // 新增按钮是否禁用
      pubSub: null,
      tableData: [],
      treeLoading: true,
      defaultProps: {
        children: 'children',
        label: 'name'
      },
      tableLoading: false,
      optionList: [
        {title: '点位名称', prop: 'name', type: 'input', default: true},
        // {title: '所属路段', prop: ['road_name_'], type: 'input', default: true},
        {title: '点位类型', prop: 'type', type: 'select', option: getDictionaryByCode('xcdwlx'), multiple: true},
        {title: '点位类别', prop: 'category', type: 'select', option: getDictionaryByCode('xcdwlb'), multiple: true},
        {title: '内容', prop: 'content', type: 'input'}
      ],
      params: {
        pageBean: {pageSize: 20, page: 1, total: 0},
        querys: [
          {operation: 'IN', property: 'roadId'},
          {operation: 'BETWEEN', property: 'createTime'},
          {operation: 'LIKE', property: 'name'},
          {group: 'roadCodeName', operation: 'LIKE', property: 'roadCode', relation: 'OR'},
          // {group: 'roadCodeName', operation: 'LIKE', property: 'road_name_', relation: 'OR'},
          {operation: 'EQUAL', property: 'direction'},
          {operation: 'LIKE', property: 'content'},
          {operation: 'IN', property: 'category'},
          {operation: 'IN', property: 'type'}
        ],
        sorter: [
          {direction: 'ASC', property: 'pegVal'},  // 点位桩号升序
          {direction: 'ASC', property: 'direction'}, // 方向升序
          {direction: 'DESC', property: 'createTime'},
          {direction: '', property: 'name'},
          {direction: '', property: 'roadCode'},
          {direction: '', property: 'direction'},
          {direction: '', property: 'pegVal'},
          {direction: '', property: 'type'},
          {direction: '', property: 'content'}
        ]
      },
      btnLoading: false,
      treeData: []
    }
  },
  computed: {
    // 通过计算属性关联querys中的配置项（格式固定）
    createTime: {
      get() {
        return getQueryValue(this.params, 'createTime')
      },
      set(val) {
        setQueryValue.call(this, this.params, 'createTime', val)
      }
    }
  },
  created() {
    // 获取树形目录
    this.getOrgTreeData(treeData => {
      // 回调中默认选中第一项并将其id作为参数请求表格
      this.treeItem = treeData[0] || {}
      let array = []
      if (this.treeItem.children.length > 0) {
        array = this.extractIds(this.treeItem)
      }
      this.$nextTick(_ => {
        this.$refs.treeSide?.setCurrentKey(treeData[0]?.id)
        this.$refs.treeSide?.expandHandle(true, 2)
      })
      setQueryValue(this.params, 'roadId', array)
      this.loadData()
    })
    // this.loadData()
  },
  mounted() {
    this.pubSub = PubSub.subscribe('TablePage', (_, data) => {
      switch (data.type) {
        case 'add':
          this.handleCurrentChange(1)
          this.loadData()
          break
        case 'edit':
          this.loadData()
          break
      }
    })

  },
  methods: {
    extractIds(node) {
      let ids = []
      // 如果当前节点有 children，则递归提取
      if (node.children) {
        ids = node.children.map(child => child.id) // 提取当前节点的 id
        // 递归提取子节点的 id
        node.children.forEach(child => {
          ids = ids.concat(this.extractIds(child))
        })
      }
      return ids
    },
    // 获取公司树
    async getOrgTreeData(callback) {
      try {
        this.treeLoading = true
        let {value} = await getTree()
        this.treeData = [value]
      } finally {
        this.treeLoading = false
        callback && callback(this.treeData)
      }
    },
    transformTreeData(data) {
      return {
        name: data.name,
        id: data.id,
        children: data.children.reduce((acc, child) => {
          acc.push({
            id: child.id,
            name: child.name,
            path: child.path,
            children: child.roadList.map(road => ({
              id: road.id,
              name: road.name,
              path: road.path
            }))
          })
          return acc
        }, [])
      }
    },
    //左边树节点
    currentChange(nodeItem) {
      if (nodeItem.id === '1766017468444450816') {
        this.isAddDisabled = true
        setQueryValue(this.params, 'roadId ', this.extractIds(nodeItem))
      } else if (nodeItem.children && nodeItem.children.length > 0) {
        this.isAddDisabled = true
        const array = nodeItem.children.map(item => item.id)
        setQueryValue(this.params, 'roadId ', array)
      } else {
        this.isAddDisabled = false
        setQueryValue(this.params, 'roadId ', [nodeItem?.id] || [])
      }
      // 判断是否是一级目录（有 children 属性）
      // if (nodeItem.children && nodeItem.children.length > 0) {
      //   this.isAddDisabled = true // 禁用新增按钮
      //   const array = nodeItem.children.map(item => item.id)
      //   setQueryValue(this.params, 'roadId ', array)
      //   this.$message.warning('请选择二级目录进行新增操作')
      // } else {
      //   this.isAddDisabled = false // 启用新增按钮
      //   // 修改对应的字段值
      //   setQueryValue(this.params, 'roadId ', [nodeItem?.id] || [])
      // }
      // 修改对应的字段值
      // setQueryValue(this.params, 'catalog_full_id_ ', nodeItem?.id || '')
      this.treeItem = nodeItem || {}
      this.calcTableHeight(500)
      PubSub.publish('TreeItemSelected', {
        id: nodeItem?.id || '',
        name: nodeItem?.name || '',
        path: nodeItem?.path || ''
      })
      this.params.pageBean.page = 1
      this.loadData()
    },
    dictionaryEscape,
    getSorterDirection,

    //获取数据
    async loadData() {
      try {
        this.tableLoading = true
        const {total = 0, rows = []} = await tableData(refineRequestBody(this.params))
        this.params.pageBean.total = total
        this.tableData = rows.map(row => ({
          ...row,
          roadName: row.roadName || this.treeItem.name // 如果 row.orgName 为空，使用 treeItem.name
        }))
      } finally {
        this.tableLoading = false
      }
    },

    // 删除
    handleDelete(row) {
      this.clickTimer = true
      setTimeout(_ => this.clickTimer = false)
      this.$confirm('确定删除选中的巡查点位吗？', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        this.btnLoading = true
        let ids = row ? row.id : this.currentDataDel.join()
        try {
          const {state} = await tableDelete(ids)
          if (state) {
            this.$message.success(`巡查点位删除成功`)
            const {page, pageSize, total} = this.params.pageBean
            const totalPages = Math.ceil(total / pageSize) // 计算总页数
            if (totalPages > 1 && page === totalPages) {
              if (this.tableData.length === 1) { // 当前页只有一条数据
                this.params.pageBean.page -= 1 // 返回前一页
              }
            }
            await this.loadData()
          }
        } finally {
          this.btnLoading = false
        }
      }).catch(_ => _)
    },
    //双击修改
    handleDbClick(row) {
      if (this.clickTimer) return (this.clickTimer = false)
      this.changePage('EditAddPage', row)
    },
    // 改变页面
    changePage(pageName = '', row = {}) {
      if (!pageName) return
      const payload = row.id ? row : {
        catalogId: this.treeItem.id,
        roadName: this.treeItem.name,
        path: this.treeItem.path,
        clearForm: true // 清空表单标志
      }
      this.$emit('changePage', pageName, _ => {
        PubSub.publish(pageName, payload)
      }, row.id ? '编辑' : '添加')
    }
  },
  beforeDestroy() {
    // 在组件销毁之前 清除订阅消息
    PubSub.unsubscribe(this.pubSub)
  }
}
</script>

<style lang="scss" scoped>
@import "~@/assets/css/element-variables";
</style>
